"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCompressionPrograms = exports.MPL_NOOP_PROGRAM_ID = exports.MPL_ACCOUNT_COMPRESSION_PROGRAM_ID = void 0;
const generated_1 = require("./generated");
exports.MPL_ACCOUNT_COMPRESSION_PROGRAM_ID = 'mcmt6YrQEMKw8Mw43FmpRLmf7BqRnFMKmAcbxE3xkAW';
exports.MPL_NOOP_PROGRAM_ID = 'mnoopTCrg4p8ry25e4bcWA9XZjbNjMTfgYVGGEdRsf3';
// Constants for known genesis blockhashes on Solana.
const SOLANA_MAINNET_GENESIS_HASH = '5eykt4UsFv8P8NJdTREpY1vzqKqZKvdpKuc147dw2N9d';
const SOLANA_DEVNET_GENESIS_HASH = 'EtWTRABZaYq6iMfeYKouRu166VU2xqa1wcaWoxPkrZBG';
const SOLANA_TESTNET_GENESIS_HASH = '4uhcVJyU9pJkvQyS88uRDiswHXSCkY3zQawwpjk2NsNY';
async function getCompressionPrograms(context) {
    const genesisHash = await context.rpc.call('getGenesisHash');
    // Determine if the genesis hash matches known clusters.
    const isSolanaCluster = [
        SOLANA_MAINNET_GENESIS_HASH,
        SOLANA_DEVNET_GENESIS_HASH,
        SOLANA_TESTNET_GENESIS_HASH,
    ].includes(genesisHash);
    // Return appropriate program IDs based on the cluster.
    if (isSolanaCluster) {
        return {
            logWrapper: generated_1.SPL_NOOP_PROGRAM_ID,
            compressionProgram: generated_1.SPL_ACCOUNT_COMPRESSION_PROGRAM_ID,
        };
    }
    return {
        logWrapper: exports.MPL_NOOP_PROGRAM_ID,
        compressionProgram: exports.MPL_ACCOUNT_COMPRESSION_PROGRAM_ID,
    };
}
exports.getCompressionPrograms = getCompressionPrograms;
//# sourceMappingURL=getCompressionPrograms.js.map